/*! @viselect/vanilla v3.6.0 MIT | https://github.com/Simonwep/selection/tree/master/packages/vanilla */
var j = Object.defineProperty;
var q = (l, n, e) => n in l ? j(l, n, { enumerable: !0, configurable: !0, writable: !0, value: e }) : l[n] = e;
var d = (l, n, e) => q(l, typeof n != "symbol" ? n + "" : n, e);
class K {
  constructor() {
    d(this, "_listeners", /* @__PURE__ */ new Map());
    // Let's also support on, off and emit like node
    /* eslint-disable no-invalid-this */
    d(this, "on", this.addEventListener);
    d(this, "off", this.removeEventListener);
    d(this, "emit", this.dispatchEvent);
  }
  addEventListener(n, e) {
    const t = this._listeners.get(n) ?? /* @__PURE__ */ new Set();
    return this._listeners.set(n, t), t.add(e), this;
  }
  removeEventListener(n, e) {
    var t;
    return (t = this._listeners.get(n)) == null || t.delete(e), this;
  }
  dispatchEvent(n, ...e) {
    let t = !0;
    for (const s of this._listeners.get(n) ?? [])
      t = s(...e) !== !1 && t;
    return t;
  }
  unbindAllListeners() {
    this._listeners.clear();
  }
}
const L = (l, n = "px") => typeof l == "number" ? l + n : l;
function S({ style: l }, n, e) {
  if (typeof n == "object")
    for (const [t, s] of Object.entries(n))
      s !== void 0 && (l[t] = L(s));
  else e !== void 0 && (l[n] = L(e));
}
const D = (l) => (n, e, t, s = {}) => {
  n instanceof HTMLCollection || n instanceof NodeList ? n = Array.from(n) : Array.isArray(n) || (n = [n]), Array.isArray(e) || (e = [e]);
  for (const o of n)
    if (o)
      for (const i of e)
        o[l](i, t, { capture: !1, ...s });
  return [n, e, t, s];
}, b = D("addEventListener"), y = D("removeEventListener"), T = (l) => {
  var s;
  const { clientX: n, clientY: e, target: t } = ((s = l.touches) == null ? void 0 : s[0]) ?? l;
  return { x: n, y: e, target: t };
};
function M(l, n, e = "touch") {
  switch (e) {
    case "center": {
      const t = n.left + n.width / 2, s = n.top + n.height / 2;
      return t >= l.left && t <= l.right && s >= l.top && s <= l.bottom;
    }
    case "cover":
      return n.left >= l.left && n.top >= l.top && n.right <= l.right && n.bottom <= l.bottom;
    case "touch":
      return l.right >= n.left && l.left <= n.right && l.bottom >= n.top && l.top <= n.bottom;
  }
}
function A(l, n = document) {
  const e = Array.isArray(l) ? l : [l];
  let t = [];
  for (let s = 0, o = e.length; s < o; s++) {
    const i = e[s];
    typeof i == "string" ? t = t.concat(Array.from(n.querySelectorAll(i))) : i instanceof Element && t.push(i);
  }
  return t;
}
const H = () => matchMedia("(hover: none), (pointer: coarse)").matches, F = () => "safari" in window, I = (l) => {
  let n, e = -1, t = !1;
  return {
    next(...s) {
      n = s, t || (t = !0, e = requestAnimationFrame(() => {
        l(...n), t = !1;
      }));
    },
    cancel() {
      cancelAnimationFrame(e), t = !1;
    }
  };
};
function W(l, n) {
  for (const e of n) {
    if (typeof e == "number")
      return l.button === e;
    if (typeof e == "object") {
      const t = e.button === l.button, s = e.modifiers.every((o) => {
        switch (o) {
          case "alt":
            return l.altKey;
          case "ctrl":
            return l.ctrlKey || l.metaKey;
          case "shift":
            return l.shiftKey;
        }
      });
      return t && s;
    }
  }
  return !1;
}
const { abs: x, max: C, min: R, ceil: B } = Math, k = (l = []) => ({
  stored: l,
  selected: [],
  touched: [],
  changed: { added: [], removed: [] }
});
class X extends K {
  constructor(e) {
    var i, r, c, h, p;
    super();
    // Options
    d(this, "_options");
    // Selection store
    d(this, "_selection", k());
    // Area element and clipping element
    d(this, "_area");
    d(this, "_clippingElement");
    // Target container (element) and boundary (cached)
    d(this, "_targetElement");
    d(this, "_targetBoundary");
    d(this, "_targetBoundaryScrolled", !0);
    d(this, "_targetRect");
    d(this, "_selectables", []);
    d(this, "_latestElement");
    // Dynamically constructed area rect
    d(this, "_areaLocation", { y1: 0, x2: 0, y2: 0, x1: 0 });
    d(this, "_areaRect", new DOMRect());
    // If a single click is being performed, it's a single-click until the user dragged the mouse
    d(this, "_singleClick", !0);
    d(this, "_frame");
    // Required data for scrolling
    d(this, "_scrollAvailable", !0);
    d(this, "_scrollingActive", !1);
    d(this, "_scrollSpeed", { x: 0, y: 0 });
    d(this, "_scrollDelta", { x: 0, y: 0 });
    /* eslint-disable no-invalid-this */
    d(this, "disable", this._toggleStartEvents.bind(this, !1));
    d(this, "enable", this._toggleStartEvents);
    this._options = {
      selectionAreaClass: "selection-area",
      selectionContainerClass: void 0,
      selectables: [],
      document: window.document,
      startAreas: ["html"],
      boundaries: ["html"],
      container: "body",
      ...e,
      behaviour: {
        overlap: "invert",
        intersect: "touch",
        triggers: [0],
        ...e.behaviour,
        startThreshold: (i = e.behaviour) != null && i.startThreshold ? typeof e.behaviour.startThreshold == "number" ? e.behaviour.startThreshold : { x: 10, y: 10, ...e.behaviour.startThreshold } : { x: 10, y: 10 },
        scrolling: {
          speedDivider: 10,
          manualSpeed: 750,
          ...(r = e.behaviour) == null ? void 0 : r.scrolling,
          startScrollMargins: {
            x: 0,
            y: 0,
            ...(h = (c = e.behaviour) == null ? void 0 : c.scrolling) == null ? void 0 : h.startScrollMargins
          }
        }
      },
      features: {
        range: !0,
        touch: !0,
        deselectOnBlur: !1,
        ...e.features,
        singleTap: {
          allow: !0,
          intersect: "native",
          ...(p = e.features) == null ? void 0 : p.singleTap
        }
      }
    };
    for (const f of Object.getOwnPropertyNames(Object.getPrototypeOf(this)))
      typeof this[f] == "function" && (this[f] = this[f].bind(this));
    const { document: t, selectionAreaClass: s, selectionContainerClass: o } = this._options;
    this._area = t.createElement("div"), this._clippingElement = t.createElement("div"), this._clippingElement.appendChild(this._area), this._area.classList.add(s), o && this._clippingElement.classList.add(o), S(this._area, {
      willChange: "top, left, bottom, right, width, height",
      top: 0,
      left: 0,
      position: "fixed"
    }), S(this._clippingElement, {
      overflow: "hidden",
      position: "fixed",
      transform: "translate3d(0, 0, 0)",
      // https://stackoverflow.com/a/38268846
      pointerEvents: "none",
      zIndex: "1"
    }), this._frame = I((f) => {
      this._recalculateSelectionAreaRect(), this._updateElementSelection(), this._emitEvent("move", f), this._redrawSelectionArea();
    }), this.enable();
  }
  _toggleStartEvents(e = !0) {
    const { document: t, features: s } = this._options, o = e ? b : y;
    o(t, "mousedown", this._onTapStart), s.touch && o(t, "touchstart", this._onTapStart, { passive: !1 });
  }
  _onTapStart(e, t = !1) {
    const { x: s, y: o, target: i } = T(e), { document: r, startAreas: c, boundaries: h, features: p, behaviour: f } = this._options, a = i.getBoundingClientRect();
    if (e instanceof MouseEvent && !W(e, f.triggers))
      return;
    const g = A(c, r), v = A(h, r);
    this._targetElement = v.find(
      (E) => M(E.getBoundingClientRect(), a)
    );
    const m = e.composedPath(), _ = g.find((E) => m.includes(E));
    if (this._targetBoundary = v.find((E) => m.includes(E)), !this._targetElement || !_ || !this._targetBoundary || !t && this._emitEvent("beforestart", e) === !1)
      return;
    this._areaLocation = { x1: s, y1: o, x2: 0, y2: 0 };
    const u = r.scrollingElement ?? r.body;
    this._scrollDelta = { x: u.scrollLeft, y: u.scrollTop }, this._singleClick = !0, this.clearSelection(!1, !0), b(r, ["touchmove", "mousemove"], this._delayedTapMove, { passive: !1 }), b(r, ["mouseup", "touchcancel", "touchend"], this._onTapStop), b(r, "scroll", this._onScroll), p.deselectOnBlur && (this._targetBoundaryScrolled = !1, b(this._targetBoundary, "scroll", this._onStartAreaScroll));
  }
  _onSingleTap(e) {
    const { singleTap: { intersect: t }, range: s } = this._options.features, o = T(e);
    let i;
    if (t === "native")
      i = o.target;
    else if (t === "touch") {
      this.resolveSelectables();
      const { x: c, y: h } = o;
      i = this._selectables.find((p) => {
        const { right: f, left: a, top: g, bottom: v } = p.getBoundingClientRect();
        return c < f && c > a && h < v && h > g;
      });
    }
    if (!i)
      return;
    for (this.resolveSelectables(); !this._selectables.includes(i); )
      if (i.parentElement)
        i = i.parentElement;
      else {
        this._targetBoundaryScrolled || this.clearSelection();
        return;
      }
    const { stored: r } = this._selection;
    if (this._emitEvent("start", e), e.shiftKey && s && this._latestElement) {
      const c = this._latestElement, [h, p] = c.compareDocumentPosition(i) & 4 ? [i, c] : [c, i], f = [...this._selectables.filter(
        (a) => a.compareDocumentPosition(h) & 4 && a.compareDocumentPosition(p) & 2
      ), h, p];
      this.select(f), this._latestElement = c;
    } else r.includes(i) && (r.length === 1 || e.ctrlKey || r.every((c) => this._selection.stored.includes(c))) ? this.deselect(i) : (this.select(i), this._latestElement = i);
  }
  _delayedTapMove(e) {
    const { container: t, document: s, behaviour: { startThreshold: o } } = this._options, { x1: i, y1: r } = this._areaLocation, { x: c, y: h } = T(e);
    if (
      // Single number for both coordinates
      typeof o == "number" && x(c + h - (i + r)) >= o || // Different x and y threshold
      typeof o == "object" && x(c - i) >= o.x || x(h - r) >= o.y
    ) {
      if (y(s, ["mousemove", "touchmove"], this._delayedTapMove, { passive: !1 }), this._emitEvent("beforedrag", e) === !1) {
        y(s, ["mouseup", "touchcancel", "touchend"], this._onTapStop);
        return;
      }
      b(s, ["mousemove", "touchmove"], this._onTapMove, { passive: !1 }), S(this._area, "display", "block"), A(t, s)[0].appendChild(this._clippingElement), this.resolveSelectables(), this._singleClick = !1, this._targetRect = this._targetElement.getBoundingClientRect(), this._scrollAvailable = this._targetElement.scrollHeight !== this._targetElement.clientHeight || this._targetElement.scrollWidth !== this._targetElement.clientWidth, this._scrollAvailable && (b(this._targetElement, "wheel", this._manualScroll, { passive: !1 }), this._selectables = this._selectables.filter((p) => this._targetElement.contains(p))), this._setupSelectionArea(), this._emitEvent("start", e), this._onTapMove(e);
    }
    this._handleMoveEvent(e);
  }
  _setupSelectionArea() {
    const { _clippingElement: e, _targetElement: t, _area: s } = this, o = this._targetRect = t.getBoundingClientRect();
    this._scrollAvailable ? (S(e, {
      top: o.top,
      left: o.left,
      width: o.width,
      height: o.height
    }), S(s, {
      marginTop: -o.top,
      marginLeft: -o.left
    })) : (S(e, {
      top: 0,
      left: 0,
      width: "100%",
      height: "100%"
    }), S(s, {
      marginTop: 0,
      marginLeft: 0
    }));
  }
  _onTapMove(e) {
    const { _scrollSpeed: t, _areaLocation: s, _options: o, _frame: i } = this, { speedDivider: r } = o.behaviour.scrolling, c = this._targetElement, { x: h, y: p } = T(e);
    if (s.x2 = h, s.y2 = p, this._scrollAvailable && !this._scrollingActive && (t.y || t.x)) {
      this._scrollingActive = !0;
      const f = () => {
        if (!t.x && !t.y) {
          this._scrollingActive = !1;
          return;
        }
        const { scrollTop: a, scrollLeft: g } = c;
        t.y && (c.scrollTop += B(t.y / r), s.y1 -= c.scrollTop - a), t.x && (c.scrollLeft += B(t.x / r), s.x1 -= c.scrollLeft - g), i.next(e), requestAnimationFrame(f);
      };
      requestAnimationFrame(f);
    } else
      i.next(e);
    this._handleMoveEvent(e);
  }
  _handleMoveEvent(e) {
    const { features: t } = this._options;
    (t.touch && H() || this._scrollAvailable && F()) && e.preventDefault();
  }
  _onScroll() {
    const { _scrollDelta: e, _options: { document: t } } = this, { scrollTop: s, scrollLeft: o } = t.scrollingElement ?? t.body;
    this._areaLocation.x1 += e.x - o, this._areaLocation.y1 += e.y - s, e.x = o, e.y = s, this._setupSelectionArea(), this._frame.next(null);
  }
  _onStartAreaScroll() {
    this._targetBoundaryScrolled = !0, y(this._targetElement, "scroll", this._onStartAreaScroll);
  }
  _manualScroll(e) {
    const { manualSpeed: t } = this._options.behaviour.scrolling, s = e.deltaY ? e.deltaY > 0 ? 1 : -1 : 0, o = e.deltaX ? e.deltaX > 0 ? 1 : -1 : 0;
    this._scrollSpeed.y += s * t, this._scrollSpeed.x += o * t, this._onTapMove(e), e.preventDefault();
  }
  _recalculateSelectionAreaRect() {
    const { _scrollSpeed: e, _areaLocation: t, _targetElement: s, _options: o } = this, { scrollTop: i, scrollHeight: r, clientHeight: c, scrollLeft: h, scrollWidth: p, clientWidth: f } = s, a = this._targetRect, { x1: g, y1: v } = t;
    let { x2: m, y2: _ } = t;
    const { behaviour: { scrolling: { startScrollMargins: u } } } = o;
    m < a.left + u.x ? (e.x = h ? -x(a.left - m + u.x) : 0, m = m < a.left ? a.left : m) : m > a.right - u.x ? (e.x = p - h - f ? x(a.left + a.width - m - u.x) : 0, m = m > a.right ? a.right : m) : e.x = 0, _ < a.top + u.y ? (e.y = i ? -x(a.top - _ + u.y) : 0, _ = _ < a.top ? a.top : _) : _ > a.bottom - u.y ? (e.y = r - i - c ? x(a.top + a.height - _ - u.y) : 0, _ = _ > a.bottom ? a.bottom : _) : e.y = 0;
    const E = R(g, m), w = R(v, _), O = C(g, m), P = C(v, _);
    this._areaRect = new DOMRect(E, w, O - E, P - w);
  }
  _redrawSelectionArea() {
    const { x: e, y: t, width: s, height: o } = this._areaRect, { style: i } = this._area;
    i.left = `${e}px`, i.top = `${t}px`, i.width = `${s}px`, i.height = `${o}px`;
  }
  _onTapStop(e, t) {
    var r;
    const { document: s, features: o } = this._options, { _singleClick: i } = this;
    y(this._targetElement, "scroll", this._onStartAreaScroll), y(s, ["mousemove", "touchmove"], this._delayedTapMove), y(s, ["touchmove", "mousemove"], this._onTapMove), y(s, ["mouseup", "touchcancel", "touchend"], this._onTapStop), y(s, "scroll", this._onScroll), this._keepSelection(), e && i && o.singleTap.allow ? this._onSingleTap(e) : !i && !t && (this._updateElementSelection(), this._emitEvent("stop", e)), this._scrollSpeed.x = 0, this._scrollSpeed.y = 0, y(this._targetElement, "wheel", this._manualScroll, { passive: !0 }), this._clippingElement.remove(), (r = this._frame) == null || r.cancel(), S(this._area, "display", "none");
  }
  _updateElementSelection() {
    const { _selectables: e, _options: t, _selection: s, _areaRect: o } = this, { stored: i, selected: r, touched: c } = s, { intersect: h, overlap: p } = t.behaviour, f = p === "invert", a = [], g = [], v = [];
    for (let _ = 0; _ < e.length; _++) {
      const u = e[_];
      if (M(o, u.getBoundingClientRect(), h)) {
        if (r.includes(u))
          i.includes(u) && !c.includes(u) && c.push(u);
        else if (f && i.includes(u)) {
          v.push(u);
          continue;
        } else
          g.push(u);
        a.push(u);
      }
    }
    f && g.push(...i.filter((_) => !r.includes(_)));
    const m = p === "keep";
    for (let _ = 0; _ < r.length; _++) {
      const u = r[_];
      !a.includes(u) && !// Check if the user wants to keep previously selected elements, e.g.,
      // not make them part of the current selection as soon as they're touched.
      (m && i.includes(u)) && v.push(u);
    }
    s.selected = a, s.changed = { added: g, removed: v }, this._latestElement = void 0;
  }
  _emitEvent(e, t) {
    return this.emit(e, {
      event: t,
      store: this._selection,
      selection: this
    });
  }
  _keepSelection() {
    const { _options: e, _selection: t } = this, { selected: s, changed: o, touched: i, stored: r } = t, c = s.filter((h) => !r.includes(h));
    switch (e.behaviour.overlap) {
      case "drop": {
        t.stored = [
          ...c,
          ...r.filter((h) => !i.includes(h))
          // Elements not touched
        ];
        break;
      }
      case "invert": {
        t.stored = [
          ...c,
          ...r.filter((h) => !o.removed.includes(h))
          // Elements not removed from selection
        ];
        break;
      }
      case "keep": {
        t.stored = [
          ...r,
          ...s.filter((h) => !r.includes(h))
          // Newly added
        ];
        break;
      }
    }
  }
  /**
   * Manually triggers the start of a selection
   * @param evt A MouseEvent / TouchEvent-like object
   * @param silent If beforestart should be fired,
   */
  trigger(e, t = !0) {
    this._onTapStart(e, t);
  }
  /**
   * Can be used if during a selection elements have been added.
   * Will update everything that can be selected.
   */
  resolveSelectables() {
    this._selectables = A(this._options.selectables, this._options.document);
  }
  /**
   * Same as deselecting, but for all elements currently selected.
   * @param includeStored If the store should also get cleared
   * @param quiet If move / stop events should be fired
   */
  clearSelection(e = !0, t = !1) {
    const { selected: s, stored: o, changed: i } = this._selection;
    i.added = [], i.removed.push(
      ...s,
      ...e ? o : []
    ), t || (this._emitEvent("move", null), this._emitEvent("stop", null)), this._selection = k(e ? [] : o);
  }
  /**
   * @returns {Array} Selected elements
   */
  getSelection() {
    return this._selection.stored;
  }
  /**
   * @returns {HTMLElement} The selection area element
   */
  getSelectionArea() {
    return this._area;
  }
  /**
   * Cancel the current selection process, pass true to fire a stop event after cancel.
   */
  cancel(e = !1) {
    this._onTapStop(null, !e);
  }
  /**
   * Unbinds all events and removes the area-element.
   */
  destroy() {
    this.cancel(), this.disable(), this._clippingElement.remove(), super.unbindAllListeners();
  }
  /**
   * Adds elements to the selection
   * @param query - CSS Query, can be an array of queries
   * @param quiet - If this should not trigger the move event
   */
  select(e, t = !1) {
    const { changed: s, selected: o, stored: i } = this._selection, r = A(e, this._options.document).filter(
      (c) => !o.includes(c) && !i.includes(c)
    );
    return i.push(...r), o.push(...r), s.added.push(...r), s.removed = [], this._latestElement = void 0, t || (this._emitEvent("move", null), this._emitEvent("stop", null)), r;
  }
  /**
   * Removes a particular element from the selection.
   * @param query - CSS Query, can be an array of queries
   * @param quiet - If this should not trigger the move event
   */
  deselect(e, t = !1) {
    const { selected: s, stored: o, changed: i } = this._selection, r = A(e, this._options.document).filter(
      (c) => s.includes(c) || o.includes(c)
    );
    r.length && (this._selection.stored = o.filter((c) => !r.includes(c)), this._selection.selected = s.filter((c) => !r.includes(c)), this._selection.changed.added = [], this._selection.changed.removed.push(
      ...r.filter((c) => !i.removed.includes(c))
    ), this._latestElement = void 0, t || (this._emitEvent("move", null), this._emitEvent("stop", null)));
  }
}
d(X, "version", "3.6.0");
export {
  X as default
};
//# sourceMappingURL=viselect.mjs.map
